unit Unit1;

{$MODE Delphi}

{
  find solutions for integer angles A,B,C,X,Y,Z such that
  sin(A)sin(B)sin(C) = sin(X)sin(Y)sin(Z) and
  A, B, C  are unequal to X, to Y or to Z
  (see Ceva lemma)
}

interface

uses
   Classes, SysUtils, Forms, Controls, Graphics, Dialogs, LCLType,
   StdCtrls, HSButton;

type

  { TForm1 }

  TForm1 = class(TForm)
    HSBtn_Go: THSButton;
    Memo1: TMemo;
    msglabel: TStaticText;
    procedure FormCreate(Sender: TObject);
    procedure HSBtn_GoClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

const degtoRad : double = pi/180;
      maxproduct = 121484; //(89-1+3)!/(89-1)! - 1

type TProduct = record
                 A1,A2,A3 : byte; //angles
                 v : longInt;     //sine product *1e9
                end;

var sinetable : array[1..89] of double; //for angles 1..89
    producttable : array[0..maxproduct] of TProduct; //sin(A)sin(B)sin(c)

procedure makesinetable;
var i : byte;
begin
 for i := 1 to 89 do sinetable[i] := sin(i*DegtoRad);
end;

procedure makeproductTable;
var i,j,k : byte;
    n : longInt;
    P : double;
begin
 n := 0;
 for i := 1 to 89 do
  for j := i to 89 do
   begin
    P := sinetable[i]*sinetable[j];
    for k := j to 89 do
     with producttable[n] do
      begin
       A1 := i; A2 := j; A3 := k;
       v := round(P*sinetable[k]*1e9);
       inc(n);
      end;
   end;
// showmessage('n='+inttostr(n-1)); //check
end;

function Intstring(L : byte; v : word) : string;
//make string of v with length L
begin
 result := inttostr(v);
 while length(result) < L do insert(' ',result,1);
end;

procedure TForm1.HSBtn_GoClick(Sender: TObject);
//search for CEVA identities
const st ='sin(';
      sp = ')';
var i,j : longInt;
    count : word;
    A1,A2,A3 : byte;
    B1,B2,B3 : byte;
    s : string;
begin
 memo1.Clear;
 count := 0;
 msglabel.Caption := '';
 for i := 0 to maxproduct-1 do
  begin
   A1 := producttable[i].A1;
   A2 := producttable[i].A2;
   A3 := producttable[i].A3;
   msglabel.Caption := 'searching '+ inttostr(A1);
   for j := i+1 to maxproduct do
    if producttable[i].v = producttable[j].v then
     begin
      B1 := producttable[j].A1;
      B2 := producttable[j].A2;
      B3 := producttable[j].A3;
      if (A1 <> B1) and (A1 <> B2) and (A1 <> B3) and
         (A2 <> B1) and (A2 <> B2) and (A2 <> B3) and
         (A3 <> B1) and (A3 <> B2) and (A3 <> B3) then
       begin
        inc(count);
        s := Intstring(4,count)+' ';
        s := s + st + intstring(2,A1) + sp;          
        s := s + st + intstring(2,A2) + sp;
        s := s + st + intstring(2,A3) + sp + ' = ';
        s := s + st + intstring(2,B1) + sp;
        s := s + st + intstring(2,B2) + sp;
        s := s + st + intstring(2,B3) + sp;
        memo1.lines.add(s);
       end;
     end;
  end;
 s := 'finished. ';
 s := s + inttostr(count)+' equalities found';
 msglabel.caption := s;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 makesinetable;
 makeproducttable;
 msglabel.caption := 'tables generated. Press GO';
end;



end.
 
